#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; EGGSMS.AU3
;
; Copyright (c) 2014 by Haute Solutions / Ed Van Every (www.haute-solutions.com)
;
; This file is free software; you can redistribute it and/or modify
; it under the terms of either the GNU General Public License version 2
; or the GNU Lesser General Public License version 2.1, both as
; published by the Free Software Foundation.
;
; This program will allow you to send an SMS Message to a Cell Phone by using an AUTOIT GUI on your local
; workstation.  The GUI accepts the Cell/SMS Phone Number and a short message and then sends this info over
; the local TCP network to the companion program running on the EGGBoard (TCPSMSRELAY.INO).  After receiving
; the info from the TCP Network, the EGGBoard then sends it out over the GSM/SMS network to the
; designated cell phone (or perhaps even another EGGBoard for delivery to some other device on a completely
; different network...)
;

#include <EditConstants.au3>
#include <GUIConstantsEx.au3>

Global $Title="EGGSMS v1.00"

; IP Address of the EGGBoard on your network
Global $EGGIP = "10.200.102.15"

; TCP Port on which the EGGBoard is listening
Global $EGGPort = 80

Global $IniFile
Global $Number = ""
Global $Msg = ""

; Determine Local INI Config file name based on Name of the Script
$IniFile = StringTrimRight(@ScriptFullPath,4) & ".ini"

;Get Workstation INI Configuration Info
GetConfig()

While GetSMSInfo() = 1
	SendSMSData($EggIP, $EGGPort, $Number, $Msg)
WEnd

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func SendSMSData($IP, $Port, $Num, $Text)

	TCPStartup()

	$IPSocket = TCPConnect($IP, $PORT)
	If @error Then
        MsgBox(4112, "Error", "TCPConnect failed with error: " & @error)
		Return 1
    EndIf

	$Cmd = $Num & @TAB & $Text

	; convert AutoIt native UTF-16 to UTF-8
	TCPSend($IPSocket, StringToBinary($Cmd, 4))
    If @error Then Return 2

	; send NULL character to end
	TCPSend($IPSocket, 0)
    If @error Then Return 3

	Return 0

EndFunc

Func GetConfig()

	If Not FileExists($IniFile) then Return

	$EGGIP = IniRead($IniFile, "Config", "EGGIP", $EGGIP)

EndFunc

Func GetSMSInfo()

	GUICreate($Title,500,140)
	$Label1  = GUICtrlCreateLabel("Please Provide SMS Information:", 110, 20, 480, 20)
	GUICtrlSetFont(-1, 8.5, 600, 4)

	$NumberLabel   = GUICtrlCreateLabel("Cell Number:",                   20,  50, 100, 20)
	$NumberData    = GUICtrlCreateInput("",                              110,  48, 370, 20)

	$MsgLabel      = GUICtrlCreateLabel("SMS Message:",                   20,  70, 100, 20)
	$MsgData       = GUICtrlCreateInput("",                              110,  68, 370, 20)

	$Cancel        = GUICtrlCreateButton("&Cancel",                      110, 100,  50)
	$OK            = GUICtrlCreateButton("&OK",                          430, 100,  50)

	GUISetState()

    While 1
        $msg = GUIGetMsg()

		Switch $msg
            Case $GUI_EVENT_CLOSE
				GUIDelete()
				Return 0
            Case $Cancel
				GUIDelete()
				Return 0
			Case $OK
				$Number=GuiCtrlRead($NumberData)
				$Msg=GuiCtrlRead($MsgData)
				GUIDelete()
				Return 1
         EndSwitch
    WEnd
EndFunc



